<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">

<head>
  <title>ThumbCreator</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <link rel="stylesheet" type="text/css" href="../common/doxygen.css" />
  <link rel="stylesheet" media="screen" type="text/css" title="KDE Colors" href="../common/kde.css" />
</head>
<body>
<div id="container">
<div id="header">
  <div id="header_top">
    <div>
      <div>
        <img alt ="" src="../common/top-kde.jpg"/>
        KDE 4.2 PyKDE API Reference
      </div>
    </div>
  </div>
  <div id="header_bottom">
    <div id="location">
      <ul>
        <li>KDE's Python API</li>
      </ul>
    </div>

    <div id="menu">
      <ul>
        <li><a href="../modules.html">Overview</a></li>
<li><a href="http://techbase.kde.org/Development/Languages/Python">PyKDE Home</a></li>
<li><a href="http://kde.org/family/">Sitemap</a></li>
<li><a href="http://kde.org/contact/">Contact Us</a></li>
</ul>
    </div>
  </div>
</div>

<div id="body_wrapper">
<div id="body">
<div id="right">
<div class="content">
<div id="main">
<div class="clearer">&nbsp;</div>

<h1>ThumbCreator Class Reference</h1>
<code>from PyKDE4.kio import *</code>
<p>



<h2>Detailed Description</h2>
<dl class="abstract" compact><dt><b>Abstract class:</b></dt>
<dd>This class can be used as a base class for new classes, but can not be instantiated directly.</dd></dl>
<p>This is the baseclass for "thumbnail-plugins" in KDE. Using the class
KIO.PreviewJob allows you to generate small images (thumbnails)
for any kind of file, where a "ThumbCreator" is available. Have a look
at kdebase/kioslave/thumbnail/ for existing ThumbCreators.
</p>
<p>
What you need to do to create and register a ThumbCreator:
<li> Inherit from this class and reimplement the create() method to </li>
generate a thumbnail for the given file-path.
<li> Provide a factory method in your implementation file to instantiate </li>
your plugin, e.g.:
<pre class="fragment">
 extern "C"
 {
   KDE_EXPORT ThumbCreator *new_creator()
   {
     return new YourThumbCreator();
   }
 };
</pre>
</p>
<p>
Compile your ThumbCreator as a module. The contents of CMakeLists.txt
should look something like this, with "filetype" replaced by the type of
file this plugin creates thumbnails for:
<pre class="fragment">
 project(filetypethumbcreator)

 find_package(KDE4 REQUIRED)
 include (KDE4Defaults)
 include(MacroOptionalAddSubdirectory)

 set(filetypethumbnail_SRCS filetypethumbnail.cpp)


 kde4_add_ui_files(filetypethumbnail_SRCS config.ui )

 kde4_add_plugin(filetypethumbnail ${filetypethumbnail_SRCS})
 target_link_libraries(filetypethumbnail ${KDE4_KIO_LIBS})

 install(TARGETS filetypethumbnail DESTINATION ${PLUGIN_INSTALL_DIR})
 install(FILES filetypethumbcreator.desktop DESTINATION ${SERVICES_INSTALL_DIR})

</pre>
</p>
<p>
<li> Create a file filetypethumbcreator.desktop with the following contents: </li>
<pre class="fragment">
 [Desktop Entry]
 Encoding=UTF-8
 Type=Service
 Name=Name of the type of files your ThumbCreator supports
 ServiceTypes=ThumbCreator
 MimeType=application/x-somemimetype;
 CacheThumbnail=true
 X-KDE-Library=yourthumbcreator
</pre>
</p>
<p>
You can supply a comma-separated list of mimetypes to the MimeTypes entry,
naming all mimetypes your ThumbCreator supports. You can also use simple
wildcards, like (where you see [slash], put a /)
<pre class="fragment">
              text[slash]* or image[slash]*.
</pre>
</p>
<p>
If your plugin is rather inexpensive (e.g. like the text preview ThumbCreator),
you can set CacheThumbnail=false to prevent your thumbnails from being cached
on disk.
</p>
<p>
Baseclass for thumbnail-generating plugins.
</p>
<table border="0" cellpadding="0" cellspacing="0"><tr><td colspan="2"><br><h2>Enumerations</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="#obj194484300">Flags</a>&nbsp;</td><td class="memItemRight" valign="bottom">{&nbsp;None, DrawFrame, BlendIcon&nbsp;}</td></tr>
<tr><td colspan="2"><br><h2>Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj193586380">create</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> path, int width, int height, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qimage.html">QImage</a> img)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">ThumbCreator.Flags&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj194430028">flags</a> (self)</td></tr>
</table>
<hr><h2>Method Documentation</h2><a class="anchor" name="obj193586380"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool create</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>path</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">int&nbsp;</td>
<td class="paramname"><em>width</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">int&nbsp;</td>
<td class="paramname"><em>height</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qimage.html">QImage</a>&nbsp;</td>
<td class="paramname"><em>img</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><dl compact><dt><b>Abstract method:</b></dt><dd>This method is abstract and can be overridden but not called directly.</dd></dl><p>Creates a thumbnail
Note that the width and height parameters should not be used
for scaling. Only plugins that create an image "from scratch",
like the TextCreator should directly use the specified size.
If the resulting preview is larger than width x height, it will be
scaled down.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>path</em>&nbsp;</td><td> the (always local) file path to create a preview for

<tr><td></td><td valign="top"><em>width</em>&nbsp;</td><td> maximum width for the preview

<tr><td></td><td valign="top"><em>height</em>&nbsp;</td><td> maximum height for the preview

<tr><td></td><td valign="top"><em>img</em>&nbsp;</td><td> this image will contain the preview on success
</td></tr>
</table></dl>
<p> <dl class="return" compact><dt><b>Returns:</b></dt><dd> true if preview generation succeeded
</dd></dl>
</p></div></div><a class="anchor" name="obj194430028"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">ThumbCreator.Flags flags</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>The flags of this plugin:
<li> None nothing special </li>
<li> DrawFrame a frame should be painted around the preview </li>
<li> BlendIcon the mimetype icon should be blended over the preview </li>
</p>
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd> flags for this plugin
</dd></dl>
</p></div></div><hr><h2>Enumeration Documentation</h2><a class="anchor" name="obj194484300"></a>
<div class="memitem">
<div class="memproto">
<table class="memname">
<tr><td class="memname">Flags</td>
</tr>
</table>
</div>
<div class="memdoc"><p>The flags of this plugin.
<dl class="see" compact><dt><b>See also:</b></dt><dd> flags()
</dd></dl>
</p><dl compact><dt><b>Enumerator: </b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0"><tr><td valign="top"><em>None</em>&nbsp;=&nbsp;0</td><td><tr><td valign="top"><em>DrawFrame</em>&nbsp;=&nbsp;1</td><td><tr><td valign="top"><em>BlendIcon</em>&nbsp;=&nbsp;2</td><td></table>
</dl>
</div></div><p>
</div>
</div>
</div>

<div id="left">

<div class="menu_box">
<div class="nav_list">
<ul>
<li><a href="../allclasses.html">Full Index</a></li>
</ul>
</div>

<a name="cp-menu" /><div class="menutitle"><div>
  <h2 id="cp-menu-project">Modules</h2>
</div></div>
<div class="nav_list">
<ul>
<li><a href="../akonadi/index.html">akonadi</a></li>
<li><a href="../dnssd/index.html">dnssd</a></li>
<li><a href="../kdecore/index.html">kdecore</a></li>
<li><a href="../kdeui/index.html">kdeui</a></li>
<li><a href="../khtml/index.html">khtml</a></li>
<li><a href="../kio/index.html">kio</a></li>
<li><a href="../knewstuff/index.html">knewstuff</a></li>
<li><a href="../kparts/index.html">kparts</a></li>
<li><a href="../kutils/index.html">kutils</a></li>
<li><a href="../nepomuk/index.html">nepomuk</a></li>
<li><a href="../phonon/index.html">phonon</a></li><li><a href="../plasma/index.html">plasma</a></li>
<li><a href="../solid/index.html">solid</a></li>
<li><a href="../soprano/index.html">soprano</a></li>
</ul></div></div>

</div>

</div>
  <div class="clearer"/>
</div>

<div id="end_body"></div>
</div>
<div id="footer"><div id="footer_text">
This documentation is maintained by <a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;simon&#64;simonzone&#46;com">Simon Edwards</a>.<br />
        KDE<sup>&#174;</sup> and <a href="../images/kde_gear_black.png">the K Desktop Environment<sup>&#174;</sup> logo</a> are registered trademarks of <a href="http://ev.kde.org/" title="Homepage of the KDE non-profit Organization">KDE e.V.</a> |
        <a href="http://www.kde.org/contact/impressum.php">Legal</a>
    </div></div>
</body>
</html>
